# Derping Drivers

GUI tool for special Windows driver tasks and signing settings.

---

⚠️ Some features of this tool do not work anymore on modern Windows versions, use at your own risk! ⚠️

---

## About

I created this program as a sort of "swiss army knife" of driver testing tasks. It can detect various situations where driver seigning requirements by the kernel are altered, like in-place upgrades from an older Windows edition, Test-Signing status and the lesser known (now no longer working) "WHQL Test Mode" 😉

## Sources

- Icon by [Rebin Infotech](https://www.iconfinder.com/rebininfotech)
- [Getting Operating System Version Info - Even for Windows 10!](https://www.codeproject.com/Articles/73000/Getting-Operating-System-Version-Info-Even-for-Win)
- [NtQuerySystemInformation](https://docs.microsoft.com/de-de/windows/desktop/api/winternl/nf-winternl-ntquerysysteminformation)
- [The TESTSIGNING Boot Configuration Option](https://docs.microsoft.com/en-us/windows-hardware/drivers/install/the-testsigning-boot-configuration-option)
- [Windows Version Numbers](http://techthoughts.info/windows-version-numbers/)
- [Super user: How do I tell if Windows 10 was a fresh install or upgrade from 7/8?](https://superuser.com/questions/1032064/how-do-i-tell-if-windows-10-was-a-fresh-install-or-upgrade-from-7-8/1184670#1184670)
- [Stack Overflow: Is there an easy way to check the .NET Framework version?](https://stackoverflow.com/questions/951856/is-there-an-easy-way-to-check-the-net-framework-version)
- [Stack Overflow: Can I have any way to detect the Driver Signing Policy status?](https://stackoverflow.com/questions/40084077/can-i-have-any-way-to-detect-the-driver-signing-policy-status/51230137#51230137)
- [Stack Overflow: Access the Windows 7 Boot Configuration Data using C#](https://stackoverflow.com/a/9405290)
- [BCDEdit: Mounting the BCD Store as a Registry Hive](http://www.mistyprojects.co.uk/documents/BCDEdit/files/bcd_as_registry_hive.htm)
- [BCDEdit: Objects and Elements](http://www.mistyprojects.co.uk/documents/BCDEdit/files/object_element_codes.htm)
- [Geoff Chappell: BCD Elements](https://www.geoffchappell.com/notes/windows/boot/bcd/elements.htm)
- [Geoff Chappell: Back Doors for Cross-Signed Drivers](https://www.geoffchappell.com/notes/security/whqlsettings/index.htm)
